import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * An actor subclass that provides movement in four directions.
 */
public class Mover extends Actor
{
    private static int speed = 4;
    
    public void moveRight()
    {
        setLocation ( getX() + speed, getY() );
    }
    
    public void moveLeft()
    {
        setLocation ( getX() - speed, getY() );
    }
    
    public void moveUp()
    {
        setLocation ( getX(), getY() - speed );
    }
    
    public void moveDown()
    {
        setLocation ( getX(), getY() + speed );
    }
    
    /**
     * Test if we are at one of the edges of the world. Return true if we are.
     */
    public boolean atWorldEdge()
    {
        if(getX() == 0 || getX() == getWorld().getWidth()-1)
            return true;
        if(getY() == 0 || getY() == getWorld().getHeight()-1)
            return true;
        else
            return false;
    }
    
    /**
     * Return true if we touch an object of class 'clss'. 
     * False if there is no such object here.
     */
    public boolean touches(Class clss)
    {
        Actor actor = getOneIntersectingObject(clss);
        return actor != null;        
    }

    
    /**
     * Try to remove an object of class 'clss'. This is only successful if we
     * are currently touching such an object. Otherwise this method does
     * nothing.
     */
    public void remove(Class clss)
    {
        Actor actor = getOneIntersectingObject(clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }

}
